Index: trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.installer/org.gvsig.installer.swing/org.gvsig.installer.swing.api/src/main/java/org/gvsig/installer/swing/api/wizard/InstallerWizardPanel.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.installer/org.gvsig.installer.swing/org.gvsig.installer.swing.api/src/main/java/org/gvsig/installer/swing/api/wizard/InstallerWizardPanel.java	(revision 43125)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.installer/org.gvsig.installer.swing/org.gvsig.installer.swing.api/src/main/java/org/gvsig/installer/swing/api/wizard/InstallerWizardPanel.java	(revision 43126)
@@ -3,65 +3,72 @@
  *
  * Copyright (C) 2007-2013 gvSIG Association.
  *
- * This program is free software; you can redistribute it and/or
- * modify it under the terms of the GNU General Public License
- * as published by the Free Software Foundation; either version 3
- * of the License, or (at your option) any later version.
+ * This program is free software; you can redistribute it and/or modify it under
+ * the terms of the GNU General Public License as published by the Free Software
+ * Foundation; either version 3 of the License, or (at your option) any later
+ * version.
  *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
+ * This program is distributed in the hope that it will be useful, but WITHOUT
+ * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
+ * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
+ * details.
  *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
- * MA  02110-1301, USA.
+ * You should have received a copy of the GNU General Public License along with
+ * this program; if not, write to the Free Software Foundation, Inc., 51
+ * Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
  *
- * For any additional information, do not hesitate to contact us
- * at info AT gvsig.com, or visit our website www.gvsig.com.
+ * For any additional information, do not hesitate to contact us at info AT
+ * gvsig.com, or visit our website www.gvsig.com.
  */
-/*
- * AUTHORS (In addition to CIT):
- * 2010 {Prodevelop}   {Task}
- */
-
 package org.gvsig.installer.swing.api.wizard;
 
+import java.io.File;
 import java.util.List;
+import org.gvsig.tools.swing.api.Component;
 
 import org.gvsig.tools.task.CancellableTask;
 
-/**
- * This interface must be implemented by all the wizards. It just have a methods
- * to manage the events that the wizard throws.
- * 
- * @author <a href="mailto:jpiera@gvsig.org">Jorge Piera Llodr&aacute;</a>
- */
-public interface InstallerWizardPanel {
+public interface InstallerWizardPanel extends Component {
 
-	/**
-	 * @param wizardActionListener
-	 *            sets the listener for the action events.
-	 */
-	public void setWizardActionListener(
-			InstallerWizardActionListener wizardActionListener);
+    /**
+     * @param wizardActionListener sets the listener for the action events.
+     */
+    public void setWizardActionListener(
+            InstallerWizardActionListener wizardActionListener);
 
-	/**
-	 * @return the listener for the action events
-	 */
-	public InstallerWizardActionListener getWizardActionListener();
+    /**
+     * @return the listener for the action events
+     */
+    public InstallerWizardActionListener getWizardActionListener();
 
-	public List<CancellableTask> getCancellableTasks();
+    public List<CancellableTask> getCancellableTasks();
 
-	public void addCancellableTask(CancellableTask task);
-	
-	/**
-	 * Tells whether this install wizard needs to restart
-     * the app after install process has finished
-     * 
-	 * @return Whether this install wizard needs to restart
-	 * the app after install process has finished
-	 */
-	public boolean needsToRestartApplicationAfterFinish();
+    public void addCancellableTask(CancellableTask task);
+
+    /**
+     * Tells whether this install wizard needs to restart the app after install
+     * process has finished
+     *
+     * @return Whether this install wizard needs to restart the app after
+     * install process has finished
+     */
+    public boolean needsToRestartApplicationAfterFinish();
+
+    public File getApplicationFolder();
+
+    public File getInstallFolder();
+
+    public void setNextButtonEnabled(boolean isEnabled);
+
+    public void setFinishButtonEnabled(boolean isVisible);
+
+    public void setCancelButtonEnabled(boolean isEnabled);
+
+    public void setBackButtonEnabled(boolean isEnabled);
+
+    public void doAction(int action);
+
+    public void skip();
+
+    public int getDirection();
 }
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.installer/org.gvsig.installer.swing/org.gvsig.installer.swing.impl/src/main/java/org/gvsig/installer/swing/impl/execution/InstallWizardPanel_ext.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.installer/org.gvsig.installer.swing/org.gvsig.installer.swing.impl/src/main/java/org/gvsig/installer/swing/impl/execution/InstallWizardPanel_ext.java	(revision 0)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.installer/org.gvsig.installer.swing/org.gvsig.installer.swing.impl/src/main/java/org/gvsig/installer/swing/impl/execution/InstallWizardPanel_ext.java	(revision 43126)
@@ -0,0 +1,66 @@
+/**
+ * gvSIG. Desktop Geographic Information System.
+ *
+ * Copyright (C) 2007-2013 gvSIG Association.
+ *
+ * This program is free software; you can redistribute it and/or modify it under
+ * the terms of the GNU General Public License as published by the Free Software
+ * Foundation; either version 3 of the License, or (at your option) any later
+ * version.
+ *
+ * This program is distributed in the hope that it will be useful, but WITHOUT
+ * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
+ * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
+ * details.
+ *
+ * You should have received a copy of the GNU General Public License along with
+ * this program; if not, write to the Free Software Foundation, Inc., 51
+ * Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
+ *
+ * For any additional information, do not hesitate to contact us at info AT
+ * gvsig.com, or visit our website www.gvsig.com.
+ */
+package org.gvsig.installer.swing.impl.execution;
+
+import java.util.List;
+import org.gvsig.gui.beans.wizard.WizardPanel;
+
+import org.gvsig.installer.lib.api.PackageInfo;
+import org.gvsig.installer.lib.api.execution.InstallPackageService;
+import org.gvsig.installer.lib.api.execution.InstallPackageServiceException;
+import org.gvsig.installer.swing.api.execution.InstallWizardPanel;
+import org.gvsig.installer.swing.impl.execution.panel.SelectBundlesPanel;
+
+public interface InstallWizardPanel_ext
+        extends
+        InstallWizardPanel, WizardPanel {
+
+    /**
+     * If this method is selected the first window of the wizard is not visible
+     * and the installation process takes the installers form the default
+     * directory.
+     *
+     * @throws InstallPackageServiceException if there an error reading the
+     * default directory.
+     */
+    public void installFromDefaultDirectory()
+            throws InstallPackageServiceException;
+
+    /**
+     * @return the installerExecutionService
+     */
+    public InstallPackageService getInstallerExecutionService();
+
+    /**
+     * @return the installersToInstall
+     */
+    public List<PackageInfo> getPackagesToInstall();
+
+    public SelectBundlesPanel getBundlesPanel();
+    
+    public String getTranslation(String key);
+
+    public void setSkipSelectPackagesWizardPage(boolean skip);
+    
+    public boolean getSkipSelectPackagesWizardPage();
+}

Index: trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.installer/org.gvsig.installer.swing/org.gvsig.installer.swing.impl/src/main/java/org/gvsig/installer/swing/impl/execution/DefaultInstallWizardPanel.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.installer/org.gvsig.installer.swing/org.gvsig.installer.swing.impl/src/main/java/org/gvsig/installer/swing/impl/execution/DefaultInstallWizardPanel.java	(revision 0)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.installer/org.gvsig.installer.swing/org.gvsig.installer.swing.impl/src/main/java/org/gvsig/installer/swing/impl/execution/DefaultInstallWizardPanel.java	(revision 43126)
@@ -0,0 +1,227 @@
+/**
+ * gvSIG. Desktop Geographic Information System.
+ *
+ * Copyright (C) 2007-2013 gvSIG Association.
+ *
+ * This program is free software; you can redistribute it and/or modify it under
+ * the terms of the GNU General Public License as published by the Free Software
+ * Foundation; either version 3 of the License, or (at your option) any later
+ * version.
+ *
+ * This program is distributed in the hope that it will be useful, but WITHOUT
+ * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
+ * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
+ * details.
+ *
+ * You should have received a copy of the GNU General Public License along with
+ * this program; if not, write to the Free Software Foundation, Inc., 51
+ * Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
+ *
+ * For any additional information, do not hesitate to contact us at info AT
+ * gvsig.com, or visit our website www.gvsig.com.
+ */
+/*
+ * AUTHORS (In addition to CIT):
+ * 2010 {Prodevelop}   {Task}
+ */
+package org.gvsig.installer.swing.impl.execution;
+
+import java.awt.BorderLayout;
+import java.io.File;
+import java.util.List;
+import javax.swing.JComponent;
+
+import org.gvsig.gui.beans.wizard.WizardPanelWithLogo;
+import org.gvsig.installer.lib.api.InstallerLocator;
+import org.gvsig.installer.lib.api.PackageInfo;
+import org.gvsig.installer.lib.api.execution.InstallPackageService;
+import org.gvsig.installer.lib.api.execution.InstallPackageServiceException;
+import org.gvsig.installer.swing.api.SwingInstallerLocator;
+import org.gvsig.installer.swing.api.SwingInstallerManager.UrlAndLabel;
+import org.gvsig.installer.swing.api.execution.PackageFilter;
+import org.gvsig.installer.swing.impl.execution.panel.SelectBundlesPanel;
+import org.gvsig.installer.swing.impl.execution.wizard.DownloadProgressWizardPage;
+import org.gvsig.installer.swing.impl.execution.wizard.AddBundlesWizardPage;
+import org.gvsig.installer.swing.impl.execution.wizard.InstallersWizardPage;
+import org.gvsig.installer.swing.impl.execution.wizard.ProgressWizardPage;
+import org.gvsig.installer.swing.impl.execution.wizard.SelectBundlesWizardPage;
+import org.gvsig.installer.swing.impl.execution.wizard.SelectPackagesWizardPage;
+import org.gvsig.installer.swing.impl.execution.wizard.TypicalOrAdvancedWizardPage;
+import org.gvsig.installer.swing.impl.wizard.AbstractInstallerWizardPanel;
+import org.gvsig.tools.ToolsLocator;
+import org.gvsig.tools.i18n.I18nManager;
+
+public class DefaultInstallWizardPanel
+        extends
+        AbstractInstallerWizardPanel
+        implements
+        InstallWizardPanel_ext {
+
+    private static final long serialVersionUID = 554068938842141497L;
+    private static final int TYPICAL_MODE = 0;
+    private static final int ADVANCED_MODE = 1;
+
+    private int installationMode = ADVANCED_MODE;
+    
+    private boolean skipTypicalOrAdvancedWizardPage = false;
+    private boolean skipSelectBundleWizardPage = false;
+    
+    private boolean selectDefaultPackages;
+
+    private InstallPackageService installerExecutionService = null;
+
+    // Wizard pages
+    private SelectBundlesWizardPage selectInstallersWizard = null;
+    private InstallersWizardPage installersWizard = null;
+    private SelectPackagesWizardPage selectPluginsWizard = null;
+    private ProgressWizardPage progressWizard = null;
+    private DownloadProgressWizardPage downloadProgressWizard = null;
+    private TypicalOrAdvancedWizardPage typicalOrAdvancedWizard = null;
+    private final AddBundlesWizardPage addBundlesWizard;
+
+    private final I18nManager i18nManager;
+    private PackageFilter packageFilter;
+
+    public DefaultInstallWizardPanel(File applicationFolder,
+            File installFolder) throws InstallPackageServiceException {
+        super(applicationFolder, installFolder);
+
+        installerExecutionService = InstallerLocator.getInstallerManager()
+                .getInstallPackageService();
+
+        this.i18nManager = ToolsLocator.getI18nManager();
+        
+        List<UrlAndLabel> downloadURLs = SwingInstallerLocator
+                .getSwingInstallerManager().getDefaultDownloadUrlAndLabels();
+        selectInstallersWizard = new SelectBundlesWizardPage(this, downloadURLs);
+        addBundlesWizard = new AddBundlesWizardPage(this);
+        typicalOrAdvancedWizard = new TypicalOrAdvancedWizardPage(this);
+        selectPluginsWizard = new SelectPackagesWizardPage(this);
+        progressWizard = new ProgressWizardPage(this);
+        downloadProgressWizard = new DownloadProgressWizardPage(this);
+        installersWizard = new InstallersWizardPage(this);
+
+        addWizards();
+
+        setFinishButtonEnabled(false);
+
+        this.setLayout(new BorderLayout());
+        super.initComponents();
+    }
+
+    @Override
+    public SelectBundlesPanel getBundlesPanel() {
+        return this.selectInstallersWizard;
+    }
+
+    private void addWizards() {
+        this.addOptionPanel(typicalOrAdvancedWizard);
+        this.addOptionPanel(selectInstallersWizard);
+        this.addOptionPanel(addBundlesWizard);
+        this.addOptionPanel(installersWizard);
+        this.addOptionPanel(selectPluginsWizard);
+        this.addOptionPanel(downloadProgressWizard);
+        this.addOptionPanel(progressWizard);
+    }
+
+    /**
+     * @return the installerExecutionService
+     */
+    @Override
+    public InstallPackageService getInstallerExecutionService() {
+        return installerExecutionService;
+    }
+
+    /**
+     * @return the installersToInstall
+     */
+    @Override
+    public List<PackageInfo> getPackagesToInstall() {
+        return this.selectPluginsWizard.getPackagesToInstall();
+    }
+
+    @Override
+    public void installFromDefaultDirectory()
+            throws InstallPackageServiceException {
+        getWizardComponents().removeWizardPanel(0);
+        installerExecutionService.addBundlesFromDirectory(getInstallFolder(), null);
+        selectPluginsWizard.updatePanel();
+    }
+
+    @Override
+    public void setSelectDefaultPackages(boolean isActivated) {
+        this.selectDefaultPackages = isActivated;
+    }
+
+    @Override
+    public boolean getSelectDefaultPackages() {
+        return this.selectDefaultPackages;
+    }
+
+    @Override
+    public void setSkipSelectPackagesWizardPage(boolean skip) {
+        if (skip) {
+            installationMode = TYPICAL_MODE;
+            selectDefaultPackages = true;
+        } else {
+            installationMode = ADVANCED_MODE;
+        }
+    }
+
+    @Override
+    public boolean getSkipSelectPackagesWizardPage() {
+        return installationMode == TYPICAL_MODE;
+    }
+    
+    @Override
+    public boolean getSkipTypicalOrAdvancedWizardPage() {
+        return skipTypicalOrAdvancedWizardPage;
+    }
+
+    @Override
+    public void setSkipTypicalOrAdvancedWizardPage(boolean skip) {
+        skipTypicalOrAdvancedWizardPage = skip;
+        if( skip ) {
+            this.installationMode = TYPICAL_MODE;
+        }
+    }
+
+    @Override
+    public void setSkipSelectBundleWizardPage(boolean skip) {
+        this.skipSelectBundleWizardPage = skip;
+    }
+
+    @Override
+    public boolean getSkipSelectBundleWizardPage() {
+        if (installationMode == TYPICAL_MODE) {
+            return true;
+        }
+        return this.skipSelectBundleWizardPage;
+    }
+
+    @Override
+    public boolean needsToRestartApplicationAfterFinish() {
+        // installers need to restart
+        return true;
+    }
+
+    @Override
+    public String getTranslation(String key) {
+        return this.i18nManager.getTranslation(key);
+    }
+
+    @Override
+    public JComponent asJComponent() {
+        return this;
+    }
+
+    @Override
+    public PackageFilter getPackageFilter() {
+        return this.packageFilter;
+    }
+
+    @Override
+    public void setPackageFilter(PackageFilter type) {
+        this.packageFilter = type;
+    }
+}

